/*
  Programme écrit par Silicium628
  ce logiciel est libre et open source

  */
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "math.h"

QString version = "2.0";

QColor couleur_ecran = QColor::fromRgb(255, 255, 255, 255);
QColor couleur_ligne = QColor::fromRgb(0, 0, 0, 255);
QColor couleur_trace1 = QColor::fromRgb(255, 0, 0, 255);
QColor couleur_trace2 = QColor::fromRgb(0, 255, 0, 255);
QColor couleur_trace3 = QColor::fromRgb(0, 0, 255, 255);
QColor couleur_texte = QColor::fromRgb(255, 255, 0, 255);

QPen pen_ligne(couleur_ligne, 1, Qt::SolidLine);
QPen pen_trace1(couleur_trace1, 1, Qt::SolidLine);
QPen pen_trace2(couleur_trace2, 1, Qt::SolidLine);
QPen pen_trace3(couleur_trace3, 1, Qt::SolidLine);
QPen pen_reticule(couleur_ligne, 1, Qt::SolidLine);


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
{
    setupUi(this);
    setWindowTitle("Equa_diff_2deg " + version);

    scene = new QGraphicsScene(this);
    scene->setBackgroundBrush(couleur_ecran);
    graphicsView1->setScene(scene);
    graphicsView1->setGeometry(5,5,610,610); // POSITION et dimensions de l'écran

    groupe_reticule = new QGraphicsItemGroup();
    scene->addItem(groupe_reticule);
    groupe_trace = new QGraphicsItemGroup();
    scene->addItem(groupe_trace);
}



MainWindow::~MainWindow()
{

}



void MainWindow::effacer_trace()
{
    foreach( QGraphicsItem *item, scene->items( groupe_trace->boundingRect() ) )
    {
        if( item->group() == groupe_trace )  { delete item; }
    }
}


void MainWindow::tracer_cadre()
{

    rectangle = new QGraphicsRectItem(0, 0, 600, 600);
    rectangle->setPen(pen_reticule);
    groupe_trace->addToGroup(rectangle);

    ligne1 = new QGraphicsLineItem(0,300,600,300);
    groupe_trace->addToGroup(ligne1);
}



void MainWindow::tracer1(int x_aff, int y_aff )
{
    if (y_aff<550)
    {
        rectangle = new QGraphicsRectItem(x_aff, 300-y_aff, 1, 1);
        rectangle->setPen(pen_trace1);
        groupe_trace->addToGroup(rectangle);
    }
}



void MainWindow::tracer2(int x_aff, int y_aff )
{
    if (y_aff<550)
    {
        rectangle = new QGraphicsRectItem(x_aff, 300-y_aff, 1, 1);
        rectangle->setPen(pen_trace2);
        groupe_trace->addToGroup(rectangle);
    }
}


void MainWindow::tracer3(int x_aff, int y_aff)
{
    if (y_aff<550)
    {
        rectangle = new QGraphicsRectItem(x_aff, 300-y_aff, 1, 1);
        rectangle->setPen(pen_trace3);
        groupe_trace->addToGroup(rectangle);
    }
}


void MainWindow::boucle_de_calcul()
{
    float q, u, i, t;
    float memo_u, memo_i, memo_q;
    float L, C;
    float q0, u0, i0;
    float dq, du, di, dt;

    q0=0;
    u0=40;
    i0=0;

    L=1e-6;        // 1uH
    C=100.0*1e-12; // 100pF
    dt=0.5e-9;     // 0.5ns

    int x_aff, y_aff;
    int n, y;

    u=u0;
    i=i0;
    for(n=0; n<600; n++)
    {
        di=u*dt/L; //le courant augmente dans la self
        i+=di; // il atteint cette valeur
        dq=i*dt; //ce qui correspond au passage de cette quantité d'électricité (charge)
        du=dq/C; //qui en entrant dans le condensateur fait varier sa tension
        u-=du; //   cette tension prend alors cette nouvelle valeur

        y = u;
        tracer1(n, 2*y);
        tracer2(n, 100*i);
    }
}





void MainWindow::on_pushButton_2_clicked()
{
    effacer_trace();
    tracer_cadre();
    boucle_de_calcul();
}



